<template>
  <div>
    <el-card class="el-card">
      <el-form :model="filterQuery" class="query-form" size="mini" label-width="100px" v-show="showSearch">
        <el-row>
          <el-col :span="6">
            <el-form-item class="query-form-item" label="单号:">
              <el-input v-model="filterQuery.billNo" placeholder="单号"
                        style="width: 90%"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item class="query-form-item" label="出入库类型:">
              <el-select v-model="filterQuery.mainAction" placeholder="请选择出入库类型" style="width: 90%">
                <el-option label="全部" value=""></el-option>
                <el-option label="入库" value="WareHouseIn"></el-option>
                <el-option label="出库" value="WareHouseOut"></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item class="query-form-item" label="单据类型:">
              <el-select v-model="filterQuery.action" placeholder="请选择单据类型"
                         style="width: 90%"
                         clearable>
                <el-option
                  v-for="item in busTypes"
                  :key="item.name"
                  :label="item.name"
                  :value="item.action">
                  <span style="float: left">{{ item.name }}</span>
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="6">
            <el-form-item class="query-form-item" label="所属仓库:">
              <el-select v-model="filterQuery.invCode" placeholder="请选择所属仓库" clearable="true"
                         style="width: 90%"
                         @change="invChange"
              >
                <el-option
                  v-for="item in invList"
                  :key="item.name"
                  :label="item.name"
                  :value="item.code">
                  <span style="float: left">{{ item.name }}</span>
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item class="query-form-item" label="创建时间:">
              <el-date-picker
                :picker-options="pickerOptions"
                v-model="actDateRange"
                type="daterange"
                format="yyyy 年 MM 月 dd 日"
                value-format="yyyy-MM-dd"
                range-separator="至"
                start-placeholder="开始日期"
                end-placeholder="结束日期"
                style="width: 90%"
              >
              </el-date-picker>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div class="top-right-btn">
        <el-button-group>
          <el-button icon="el-icon-view" type="primary" @click="hideSearch">显示/隐藏搜索栏</el-button>
          <el-button
            type="primary"
            icon="el-icon-refresh"
            @click="onReset"
          >重置
          </el-button>
          <el-button type="primary" icon="el-icon-search" @click="onSubmit"
          >查询
          </el-button
          >
          <el-button type="primary" icon="el-icon-plus" @click="addOrders">新增单据</el-button>
        </el-button-group>
      </div>
      <el-divider style="margin: 15px"></el-divider>
      <el-table v-loading="loading" :data="list" style="width: 100%" highlight-current-row
                border
      >
        <el-table-column type="selection" width="55"></el-table-column>
        <el-table-column label="序号" type="index"></el-table-column>
        <el-table-column label="扫码单据类型" prop="billTypeName">
        </el-table-column>
        <el-table-column label="订单号" prop="billNo" show-overflow-tooltip></el-table-column>
        <el-table-column label="来源订单号" prop="corpOrderId" show-overflow-tooltip></el-table-column>
        <el-table-column label="来源" prop="fromType">
          <template slot-scope="scope">
            <span>{{ fromTypeMap[scope.row.fromType] }}</span>
          </template>
        </el-table-column>
        <el-table-column label="往来单位" prop="fromName" width="220">
        </el-table-column>
        <el-table-column label="当前仓库" prop="invName" width="120">
        </el-table-column>
        <el-table-column label="所属科室" prop="deptName" width="120" v-if="enableDept">
        </el-table-column>
        <el-table-column label="创建时间" prop="createTime" show-overflow-tooltip>
          <template slot-scope="scope">
            <i class="el-icon-time"></i>
            <span>{{ scope.row.createTime }}</span>
          </template>
        </el-table-column>
        <el-table-column label="校验状态" prop="status" width="100">
          <template slot-scope="scope">
            <el-tag :type="statusFilterType(scope.row.status)">{{
                checkStatus[scope.row.status]
              }}
            </el-tag>
          </template>
        </el-table-column>
        <el-table-column label="操作" width="150">
          <template slot-scope="scope">
            <el-button
              type="text"
              size="small"
              @click.native.stop="editOrder(scope.row)"
            >编辑
            </el-button
            >
            <el-button
              type="text"
              size="small"
              @click.native.stop="deleteDialog(scope.row.billNo)"
            >删除
            </el-button
            >
            <el-button
              type="text"
              size="small"
              v-if="scope.row.status == 1"
              @click.native.stop="onUpload(scope.row.billNo)"
            >立即提交
            </el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <el-dialog
        :title="titleMap[title]"
        :visible.sync="addOrderVisible"
        width="85%"
        append-to-body
        :close-on-click-modal="false"
        :close-on-press-escape="false"
        v-if="addOrderVisible"
        @close='closeDialog'
      >
        <addOrder
          :closeDialog="closeDialog"
          :orderQuery="idQuery"
          :viewType="viewType"
        ></addOrder>
      </el-dialog>
      <pagination
        v-show="total>0"
        :total="total"
        :page.sync="filterQuery.page"
        :limit.sync="filterQuery.limit"
        @pagination="getList"
      />
    </el-card>
  </div>
</template>

<script>
import {
  deleteByOrderId,
  getOrderList, submitCodes
} from "../../api/inout/order";
import addOrder from "./DialogCreateOrder";
import {getInvListByUser} from "@/api/system/invWarehouse";
import {getLocalJoinByUser} from "@/api/basic/busType";
import {selectSysParamByKey} from "@/api/param/systemParamConfig";

export default {
  name: "IoCreateScanOrder",
  data() {
    return {
      showSearch: true,
      titleMap: {
        add: "新增单据",
        edit: "编辑单据",
      },
      title: "add",

      filterQuery: {
        id: "",
        billNo: null,
        mainAction: null,
        action: null,
        statusType: "scan_code",
        page: 1,
        limit: 10,
        startTime: null,
        endTime: null,
        invCode: this.$store.getters.locInvCode,
      },
      checkStatus: {
        1: "草稿",
        2: "等待处理",
        3: "等待校验",
        4: "处理异常",
        5: "校验成功",
        6: "校验异常",
        7: "审核通过",
        8: "审核拒绝",
        9: "正在处理"
      },
      curIndex: "",
      idQuery: {},
      storageList: [],
      invList: [],
      list: [],
      addOrderVisible: false,
      total: 0,
      loading: false,
      index: null,
      formName: null,
      errorDetail: "",
      formMap: {
        add: "新增",
        edit: "编辑",
      },
      enableDept: false,
      fromTypeMap: {
        "1": "UDIMS平台",
        "2": "网页新增",
        "3": "pda即时校验",
        "4": "pda未校验",
        "5": "pc端扫码精灵",
        "6": "缺量补录单据",
        "7": "UDI供应商平台",
        "8": "平衡补录单据",
        "10": "手动补单",
        "11": "仓库盘点",
        "12": "采购计划",
        "13": "领用单据",
        "14": "第三方系统单据",
      },
      deleteData: {
        billNo: "",
        status: 10,
      },
      dialogTableVisible: false,
      formLoading: false,
      deleteLoading: false,
      busTypes: [],
      actDateRange: [],
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
      viewType: 2,
    };
  },

  components: {
    addOrder,
  },
  methods: {
    onReset() {
      this.filterQuery = {
        id: "",
        billNo: null,
        mainAction: null,
        action: null,
        statusType: "scan_code",
        page: 1,
        limit: 10,
        startTime: null,
        endTime: null,
        invCode: this.$store.getters.locInvCode,
      };
      this.actDateRange = [];
      this.getList();
    },
    onSubmit() {
      if (this.actDateRange !== null) {
        this.filterQuery.startTime = this.actDateRange[0];
        this.filterQuery.endTime = this.actDateRange[1];
      } else {
        this.filterQuery.startTime = null;
        this.filterQuery.endTime = null;
      }
      this.filterQuery.page = 1;
      this.getList();
    },
    hideSearch() {
      this.showSearch = !this.showSearch;
    },
    getBusType() {
      let query = {
        code: this.filterQuery.invCode,
        enabled: true,
      };
      getLocalJoinByUser(query)
        .then((response) => {
          this.busTypes = response.data.list || [];
          this.getList();
        })
        .catch(() => {
        });
    },
    addOrders() {
      this.idQuery = {};
      this.title = "add";
      this.addOrderVisible = true;
    },

    editOrder(row) {
      this.idQuery = row;
      this.title = "edit";
      this.addOrderVisible = true;
    },

    closeDialog() {
      this.addOrderVisible = false;
      this.addHosOrderVisible = false;
      this.getList();
    },

    //获取订单列表
    getList() {
      this.loading = true;
      getOrderList(this.filterQuery)
        .then((response) => {
          this.loading = false;
          if (response.code === 20000) {
            this.list = response.data.list || [];
            this.total = response.data.total || 0;
          } else {
            this.$message.error(response.message);
          }
        })
        .catch((error) => {
          this.$message.error(error.message)
          this.loading = false;
          this.list = [];
          this.total = 0;
        });
    },
    deleteOrders(data) {
      this.loading = true;
      this.deleteData.billNo = data;
      deleteByOrderId(this.deleteData)
        .then((response) => {

          if (response.code == 20000) {
            this.getList();
            this.$message({
              type: "success",
              message: "删除成功！",
            });
          } else if (response.code == 520) {
            this.$message.error("新增扫码单据列表已不存在该扫码单据！");
            this.getList();
          }

        })
        .catch(() => {
        });
    },
    deleteDialog(rowId) {
      this.$confirm("此操作将永久删除该订单, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.deleteOrders(rowId);
        })
        .catch(() => {
        });
    },
    onUpload(data) {
      this.loading = true;
      var idQuery = {
        billNo: "",
      };
      idQuery.billNo = data;
      submitCodes(idQuery)
        .then((response) => {
          this.loading = false;
          if (response.code === 20000) {
            this.$message.success("提交成功");
            this.getList();
          } else {
            this.$message.error(response.message);
          }
          this.loading = false;
        });
    },
    getInvList() {
      getInvListByUser()
        .then((response) => {
          this.invList = response.data || [];
          this.getList();
        })
        .catch(() => {
        });
    },
    invChange() {
      this.filterQuery.action = null;
      this.getBusType();
    },

    statusFilterType(status) {
      const statusMap = {
        2: "warning",
        1: "warning",
        4: "danger",
        3: "success",
      };
      return statusMap[status];
    },

  },
  mounted() {
    document.body.ondrop = function (event) {
      event.preventDefault();
      event.stopPropagation();
    };
  },
  created() {
    this.getInvList();
    this.getBusType();
    this.getList();
    selectSysParamByKey({paramKey: "muti_inv_mode"}).then((res) => {
      if (res.code === 20000) {
        if (res.data.paramValue === "0") {
          this.enableDept = true;
        }
      }
    })

  },
};
</script>

<style type="text/scss" lang="scss">
</style>

